<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: ControladorPlan.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: ControladorPlan.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>'use strict';
var models = require('./../models/');
var uuid = require('uuid');

/**
 * @class ControladorPlan
 */
class ControladorPlan {
    /**
     * @description Permite visualizar la ventana de Plan, en la cuál se podrá pagar por el plan premium
     * @param {req} req Obtiene el external id de la persona, y también presenta los mensajes de información o de error
     * @param {res} res Direcciona a la ventana de Plan, y en el caso de que exista algún error, lo redirige a la ventana principal 
     * @returns {undefined}
     */
    visualizar(req, res) {
        var pagos = models.pagos;
        var persona = models.persona;
        var external_persona = req.user.id;
        persona.findAll({include: [{model: pagos, as: 'pagos'}]}).then(function (datos) {
            if (datos) {
                res.render('index',
                        {
                            title: 'Aureo | Canciones',
                            fragmentos: "Plan",
                            info: datos,
                            external: external_persona,
                            msg: {error: req.flash('error'), info: req.flash('info')}

                        });
            } else {
                req.flash('error', 'Presentamos problemas');
                res.redirect('/');
            }
        }).error(function (error) {
            req.flash('error', 'Temporalmente no se puede obtener premin');
            res.redirect('/');
        });
    }

    /**
     * @description Permite visualizar la ventana de tarjeta, en la cual pondrá sus datos personales de la tarjeta de crédito
     * @param {req} req Obtiene el external id de la persona, y también presenta los mensajes de información o de error
     * @param {res} res Direcciona a la ventana de Tarjeta, y en el caso de que exista algún error, lo redirige a la ventana principal 
     * @returns {undefined}
     */
    visualizar_tar(req, res) {
        var pagos = models.pagos;
        var persona = models.persona;
        var external = req.params.external;
        persona.findAll({where: {external_id: external}, include: [{model: pagos, as: 'pagos'}]}).then(function (datos) {
            if (datos) {
                res.render('index',
                        {
                            title: 'Aureo | Canciones',
                            fragmentos: "Tarjeta",
                            info: datos,
                            msg: {error: req.flash('error'), info: req.flash('info')}

                        });
                console.log(datos);
            } else {
                req.flash('error', 'Presentamos problemas');
                res.redirect('/');
            }
        }).error(function (error) {
            req.flash('error', 'Temporalmente no se puede obtener premin');
            res.redirect('/');
        });
    }

    /**
     * @description Permite guardar todos los datos del plan junto con el usuario en la base de datos
     * @param {req} req Obtiene todos los datos del plan de pagos
     * @param {res} res Redirecciona a la venta Perfil en el caso de que todo se ejecute correctamente
     * @returns {undefined}
     */
    guardar(req, res) {
        var pagos = models.pagos;
        var persona = models.persona;
        persona.findOne({include: [{model: pagos, as: 'pagos'}]}).then(function (datospagos) {
            if (datospagos) {

                var datosrelacionados = {
                    costo: req.body.costo,
                    fecha: req.body.fechas,
                    nombre_plan: req.body.plan,
                    id_persona: datospagos.id,
                    external_id: uuid.v4()
                };
                pagos.create(datosrelacionados, {include: [{model: models.persona}]}).then(function (lista) {
                    req.flash('info', "Ha solicitado el plan Premium, se habilitará en unas horas...");
                    res.redirect("/Perfil");
                });


            }
        });
    }

}


module.exports = ControladorPlan;

</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="ControladorPlan.html">ControladorPlan</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Sun Aug 25 2019 04:13:21 GMT-0500 (GMT-05:00)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
